pub mod repo;
pub use repo::Repository;
pub mod package;
pub use package::Package;
pub mod arch;
pub mod db;
pub mod mirror;

pub fn find_package_by_name(pkg: &str) -> Option<Package> {
    for repo in Repository::list() {
        let repo = Repository::new(&repo).unwrap();
        let pkgs = repo.list_pkg();

        if let Some(res) = pkgs.iter().find(|x| *x == pkg) {
            return repo.get_pkg_by_name(res);
        }
    }

    None
}
